package com.sun.corba.se.impl.presentation.rmi;

import javax.rmi.CORBA.Tie;
import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.SystemException;
import java.rmi.RemoteException;
import com.sun.corba.se.impl.corba.CORBAObjectImpl;
import org.omg.CORBA.BAD_INV_ORDER;
import org.omg.CORBA.BAD_OPERATION;
import com.sun.corba.se.impl.util.Utility;
import com.sun.corba.se.spi.presentation.rmi.StubAdapter;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.ObjectImpl;
import org.omg.CORBA.Object;
import com.sun.corba.se.impl.ior.StubIORImpl;
import com.sun.corba.se.impl.logging.UtilSystemException;

public abstract class StubConnectImpl
{
    static UtilSystemException wrapper;
    
    public StubConnectImpl() {
    }
    
    public static StubIORImpl connect(StubIORImpl stubIORImpl, org.omg.CORBA.Object object, ObjectImpl objectImpl, ORB orb) throws RemoteException {
        try {
            try {
                if (StubAdapter.getDelegate(objectImpl).orb(objectImpl) != orb) {
                    throw StubConnectImpl.wrapper.connectWrongOrb();
                }
            }
            catch (BAD_OPERATION bad_OPERATION) {
                Delegate delegate;
                if (stubIORImpl == null) {
                    Tie andForgetTie = Utility.getAndForgetTie(object);
                    if (andForgetTie == null) {
                        throw StubConnectImpl.wrapper.connectNoTie();
                    }
                    try {
                        orb = andForgetTie.orb();
                    }
                    catch (BAD_OPERATION bad_OPERATION2) {
                        andForgetTie.orb(orb);
                    }
                    catch (BAD_INV_ORDER bad_INV_ORDER) {
                        andForgetTie.orb(orb);
                    }
                    if (orb != orb) {
                        throw StubConnectImpl.wrapper.connectTieWrongOrb();
                    }
                    delegate = StubAdapter.getDelegate(andForgetTie);
                    CORBAObjectImpl o = new CORBAObjectImpl();
                    o._set_delegate(delegate);
                    stubIORImpl = new StubIORImpl(o);
                }
                else {
                    delegate = stubIORImpl.getDelegate(orb);
                }
                StubAdapter.setDelegate(objectImpl, delegate);
            }
        }
        catch (SystemException cause) {
            throw new RemoteException("CORBA SystemException", cause);
        }
        return stubIORImpl;
    }
    
    static {
        StubConnectImpl.wrapper = UtilSystemException.get("rmiiiop");
    }
}
